<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>SPA</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
</head>
<body>

<nav class="navbar navbar-expand-lg navbar-dark" style="background-color: red;">
    <a class="navbar-brand" href="#">SPA</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarNav">
        <ul class="navbar-nav">
            <li class="nav-item active">
                <a class="nav-link" href="#" id="homeLink">Main <span class="sr-only">(current)</span></a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="#" id="createPostLink">Add post</a>
            </li>
        </ul>
    </div>
</nav>

<div class="container mt-5">
    <div id="content">
        <div id="homeContent">
            <h2>All posts</h2>
            <ul id="postList" class="list-group">
            </ul>
        </div>
        <div id="createPostForm" style="display: none;">
            <h2>Add post</h2>
            <form id="postForm">
                <div class="form-group">
                    <label for="postTitle">Title:</label>
                    <input type="text" class="form-control" id="postTitle" required>
                </div>
                <div class="form-group">
                    <label for="postBody">Body:</label>
                    <textarea class="form-control" id="postBody" rows="3" required></textarea>
                </div>
                <div class="form-group">
                    <label for="postUserId">User(ID):</label>
                    <input type="number" class="form-control" id="postUserId" required>
                </div>
                <button type="submit" class="btn btn-primary">Create</button>
            </form>
        </div>
    </div>
</div>

<script>
    $(document).ready(function() {
        showAllPosts();

        $('#homeLink').click(function(event) {
            event.preventDefault();
            showAllPosts();
        });

        $('#createPostLink').click(function(event) {
            event.preventDefault();
            showCreatePostForm();
        });

        function showAllPosts() {
            $('#content').children().hide();
            $('#homeContent').show();

            fetch("https://jsonplaceholder.typicode.com/posts")
                .then(response => response.json())
                .then(posts => {
                    $('#postList').empty();
                    posts.forEach(post => {
                        $('#postList').append(`<li class="list-group-item">${post.title}
                            <button type="button" class="btn btn-sm btn-primary edit-btn" data-post-id="${post.id}">Edit</button>
                            <button type="button" class="btn btn-sm btn-danger delete-btn" data-post-id="${post.id}">Delete</button></li>`);
                    });

                    $('.edit-btn').click(function() {
                        let postId = $(this).data('post-id');
                        editPost(postId);
                    });

                    $('.delete-btn').click(function() {
                        let postId = $(this).data('post-id');
                        deletePost(postId);
                    });
                })
                .catch(error => {
                    console.error('Error in post loading:', error);
                    alert('Try again bro!');
                });
        }

        function showCreatePostForm() {
            $('#content').children().hide();
            $('#createPostForm').show();

            $('#postForm').submit(function(event) {
                event.preventDefault();
                let title = $('#postTitle').val();
                let body = $('#postBody').val();
                let userId = $('#postUserId').val();

                fetch("https://jsonplaceholder.typicode.com/posts", {
                    method: 'POST',
                    body: JSON.stringify({
                        title: title,
                        body: body,
                        userId: userId
                    }),
                    headers: {
                        'Content-type': 'application/json; charset=UTF-8',
                    },
                })
                    .then(response => response.json())
                    .then(data => {
                        alert('Post successfully created!');
                        showAllPosts();
                    })
                    .catch(error => {
                        console.error('Error by creating:', error);
                        alert('Try create post again');
                    });
            });
        }

        function editPost(postId) {
            let newTitle = prompt("Enter the new title for post:");
            let newBody = prompt("Enter the new body for post:");

            fetch(`https://jsonplaceholder.typicode.com/posts/${postId}`, {
                method: 'PUT',
                body: JSON.stringify({
                    id: postId,
                    title: newTitle,
                    body: newBody
                }),
                headers: {
                    'Content-type': 'application/json; charset=UTF-8',
                },
            })
                .then(response => response.json())
                .then(data => {
                    alert('Post successfully updated');
                    showAllPosts();
                })
                .catch(error => {
                    console.error('Error by editing post:', error);
                    alert('Try edit post again');
                });
        }

        function deletePost(postId) {
            fetch(`https://jsonplaceholder.typicode.com/posts/${postId}`, {
                method: 'DELETE'
            })
                .then(response => {
                    if (response.ok) {
                        alert('Post successfully deleted');
                        showAllPosts();
                    } else {
                        throw new Error('Error while deleting');
                    }
                })
                .catch(error => {
                    console.error('Error while deleting:', error);
                    alert('I have no idea, why post didn\'t deleted. Try it again!');
                });
        }
    });
</script>
</body>
</html>
